#include "conf.h"
#include "filed.h"
#include "externs.h"
#include "log.h"
#include "main.h"
#include "sys.h"

void read_cf(void) {
	int i;
	char *c;

	if(!(filed->cf = parse_file(filed->conf_file))) {
		elog("Unable to parse file [%s]",filed->conf_file);
		exit(0);
	}

	if((i = get_one_data_int(filed->cf,"debug")) == -1)
		debug = 0;
		else
		debug = i;

	/* verify all required entries are there */
	/* insert defaults if no entry present */

	if(get_one_data_int(filed->cf,"peer-hb") == -1)
		ins_one(filed->cf,"peer-hb 5");
	if(get_one_data_int(filed->cf,"peer-timeout") == -1)
		ins_one(filed->cf,"peer-timeout 30");
	if(get_one_data_int(filed->cf,"peer-reconnect") == -1)
		ins_one(filed->cf,"peer-reconnect 60");	
	if(!get_data(filed->cf,"banner"))
		ins_one(filed->cf,"banner \"Filed %V\"");
	if(!get_data(filed->cf,"shmem-key")) {
		elog("%s: need shmem-key entry",filed->conf_file);
		die();
	}
	if(!get_data(filed->cf,"port"))
		ins_one(filed->cf,"port 1955");
	if(!get_data(filed->cf,"dbuser")) {
		elog("%s: need dbuser entry",filed->conf_file);
		die();
	}
	if(!get_data(filed->cf,"dbpass")) {
		elog("%s: need dbpass entry",filed->conf_file);
		die();
	}

	if((c = get_data(filed->cf,"hostname"))) {
		strcpy(filed->hostname,c);
	} else {
		if(!strcmp(filed->hostname,"")) {
			elog("Unable to determine hostname");
			die();
		}
	}		

	if(debug) dlog(DEBUG_MAIN,"Debugging: %s",get_debug_string(debug));
}
