#ifndef __io_h
#define __io_h
#include "filed.h"
#include "parse.h"

void process_io(void);
char *generate_welcome(void);
void process_input(struct connection *c);
void process_errors(struct connection *c);
void process_human(struct connection *c);
void process_java(struct connection *c);
void process_peer(struct connection *c);
void process_disconnect(struct connection *c);

void parse_human(struct connection *c, struct queue *q);
void parse_java(struct connection *c, struct queue *q);
void parse_peer(struct connection *c, struct queue *q);

void shmem_subparse(struct connection *c, struct parse *p);
void peer_subparse(struct connection *c, struct parse *p);
void debug_subparse(struct connection *c, struct parse *p);

void do_who(struct connection *c);
void do_shutdown(struct connection *c, struct parse *p);
void do_clear(struct connection *c, struct parse *p);

void go_down(struct connection *c);
void go_up(struct connection *c);


#define CTYPE_HUMAN 1
#define CTYPE_JAVA 0
#define CTYPE_PEER 2

#endif
